/* Uniform, scalar dithered quantizer. */

/* Brian Chen (bchen@alum.mit.edu)
   Massachusetts Institute of Technology
   October 1999 */

/* The purpose of publishing this software code is to educate others
   and encourage further research activity in this QIM area of
   technology.  Nothing herein, however, shall be construed as
   offering a license under any intellectual property right (such as
   patent or copyright) to use the software for any commercial
   application.  Should you be interested in using this or related
   software or technology for any commercial application, please
   contact

        Jack Turner
	Associate Director
	MIT Technology Licensing Office
	77 Massachusetts Ave., Rm. NE25-230
	Cambrige, MA  02139
	(617) 253-6966
	jht@mit.edu

   to discuss licensing opportunities. */


#include <math.h>
double rint(double x);

double dith_quant( double x, double delta, double dith )
/* x     --> input symbol
   delta --> quantization step size
   dith  --> dither value */
{
  return ( delta*rint((x+dith)/delta) - dith );
}


double rint(double x)
/* Round x to nearest integer.  This should already be in some math.h
   libraries but, apparently, not in Microsoft Visual C */
{
	return( floor(x+0.5) );
}
